local tmp = package.path
package.path = package.path .. ";UAV.rte/?.lua"
require("common")
package.path = tmp

function Create(self)
	UAVInitialize(self)
	
	-- specific for this craft
	self.occlusion = 70
--	self.payload = 1
	self.payloadRof = 400	-- time in ms between drops
	
	self.Missile = CreateMOSRotating("Jericho Dummy", "UAV.rte")
	self.Missile.Vel = self.Vel
	self.Missile.Pos = self.Pos + self:RotateOffset(Vector(8, math.abs(self.Missile.SpriteOffset.Y) + 10))
	self.Missile.RotAngle = self.RotAngle
	MovableMan:AddParticle(self.Missile)
end

function Destroy(self)
	UAVDestroy(self)
	
	if self.Missile ~= nil then
		self.Missile.ToDelete = true
		
		local Missile = CreateAEmitter("Jericho Missile", "UAV.rte")
		Missile.Vel = self.Vel
		Missile.Pos = self.Pos + self:RotateOffset(Vector(8, math.abs(Missile.SpriteOffset.Y) + 15))
		Missile.RotAngle = self.angle
		MovableMan:AddParticle(Missile)
		Missile:EnableEmission(false)
	end
end

function Update(self)
	self.angle = self.RotAngle
	if self.HFlipped then
		self.angle = self.angle + math.pi
	end
	
	if self.RotAngle > math.pi or self.RotAngle < -math.pi then
		self.RotAngle = 0
		self.HFlipped = not self.HFlipped
	end
	
	-- movement in direction of view angle
	self.speed = math.abs(self.Vel.Magnitude * math.cos(math.abs(self.Vel.AbsRadAngle - self.RotAngle)))
	
	UAVMove(self)
	
	-- Move the Jericho
	if self.Missile ~= nil and MovableMan:ValidMO(self.Missile) then
		self.Missile.Pos = self.Pos + self:RotateOffset(Vector(8, math.abs(self.Missile.SpriteOffset.Y) + 10))
		self.Missile.RotAngle = self.angle
	end
	
	if ToActor(self):IsPlayerControlled() then
		self.playerCtrl = true
		UAVMap(self)
		
		-- MGs
		if self:GetController():IsState(Controller.PRIMARY_ACTION) then
			if self.ammo > 0 then
				UAVFireMG(self)
			else
				UAVAddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
	
		-- specific for this craft
		if self.DropTimer:IsPastSimMS(self.payloadRof) and (self:GetController():IsMouseControlled() and UAVSecondaryKey()) or
			(not self:GetController():IsMouseControlled() and self:GetController():IsState(Controller.AIM_SHARP))
		then
			if self.Missile ~= nil then
				self.DropTimer:Reset()
				
				self.Missile.ToDelete = true
				self.Missile = nil

				local Missile = CreateAEmitter("Jericho Missile", "UAV.rte")
				Missile.Vel = UAVOffset(self.Vel, self.angle, 3)
				Missile.Pos = self.Pos + self:RotateOffset(Vector(8, math.abs(Missile.SpriteOffset.Y) + 12))
				Missile.RotAngle = self.angle
				MovableMan:AddParticle(Missile)
				
				self.Mass = 450
				for i = 1, 8 do
					self:AddInventoryItem(CreateHDFirearm(".", "UAV.rte"))	-- Negative Gold
				end
			else
				UAVAddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
	elseif self.playerCtrl then
		UAVDestroy(self)
	end
end